<?php

require '../header.php';
require '../variables.php';
require '../functions.php';

require_login();

if ( !isset($_REQUEST['kindlemail']) ) {
   exit();
}

$data = array();
$data['success'] = true;
$data['message'] = "";
$data['kindlemail'] = "";

if ( !filter_var($_REQUEST['kindlemail'], FILTER_VALIDATE_EMAIL) ) {
   $data['success'] = false;
   $data['message'] = "Email address is not properly formatted!";
   header('Content-Type: application/json');
   echo json_encode($data);
   exit();
}

$kindlemail = $_REQUEST['kindlemail'];
$query = "INSERT INTO amazon (username, email) VALUES(:username, :email) ON DUPLICATE KEY UPDATE email=:email";
$sth = $globaldbh->prepare($query);
$sth->bindValue(":username", $_SESSION['username'], PDO::PARAM_STR);
$sth->bindValue(":email", $_REQUEST['kindlemail'], PDO::PARAM_STR);
$sth->execute();

header('Content-Type: application/json');
$data['message'] = "Email set successfully";
$data['kindlemail'] = $_REQUEST['kindlemail'];
echo json_encode($data);
exit();

// vim: ts=3 sw=3 et:
